<?php
/**
 * Hello Model for Hello World Component
 * 
 * @package    Joomla.Tutorials
 * @subpackage Components
 * @link http://docs.joomla.org/Developing_a_Model-View-Controller_Component_-_Part_2
 * @license    GNU/GPL
 */
 
// No direct access
 
defined( '_JEXEC' ) or die( 'Restricted access' );
 
jimport( 'joomla.application.component.model' );
 
/**
 * Hello Model
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 */
class IntuitModelIntuit extends JModel
{
	
	/**
     * Construct Method
     * @return string The query to be used to retrieve the rows from the database
     */
	 
	  function __construct()
	  {
		parent::__construct();
	
		global $mainframe, $option;
			
	  }
	  
			
	  
	 /**
     * Returns the query
     * @return string The query to be used to retrieve the rows from the database
     */
		function getSubmitIntuit()
		{
			$submit = JRequest::getVar('SubmitIntuit', null, 'SubmitIntuit', 'string');
			
			return $submit;
		}	 
	
	  
    /**
    * Gets the greeting
    * @return string The greeting to be displayed to the user
    */
    function getIntuitPayment()
    {
		$db = JFactory::getDBO();
        $sql = "SELECT * FROM #__intuit_gateway WHERE gateway_id = 'intuit'";
		$db->setQuery( $sql );	
		$alt_intuit_fields = $db->loadObjectList();
		foreach ($alt_intuit_fields as $alt_intuit_field)
        {
            $intuit_fields[$alt_intuit_field->g_key] = array();
            $intuit_fields[$alt_intuit_field->g_key]['g_key'] = $alt_intuit_field->g_key;
            $intuit_fields[$alt_intuit_field->g_key]['g_value'] = $alt_intuit_field->g_value;
        }
		$transaction = $intuit_fields;	  
		$transaction['fulltotal']['g_value'] = JRequest::getVar('fulltotal');
		$transaction['cardtype']['g_value'] = JRequest::getVar('credit_card');
		$transaction['ccnumber']['g_value'] = JRequest::getVar('credit_card_num');
		$transaction['month']['g_value'] = JRequest::getVar('ex_month');
		$transaction['year']['g_value'] = JRequest::getVar('ex_year');
		$transaction['ccname']['g_value'] = JRequest::getVar('cc_name');
		$transaction['baddress']['g_value'] = JRequest::getVar('b_address');
		$transaction['baddress1']['g_value'] = JRequest::getVar('b_address1');
		$transaction['bcity']['g_value'] = JRequest::getVar('b_city');
		$transaction['bstate']['g_value'] = JRequest::getVar('b_state');
		$transaction['bzip']['g_value'] = JRequest::getVar('b_zip');
		$transaction['bcountry']['g_value'] = JRequest::getVar('b_country');
		$transaction['bphone']['g_value'] = JRequest::getVar('b_phone');
		$transaction['bfax']['g_value'] = JRequest::getVar('b_fax');
		$transaction['email']['g_value'] = JRequest::getVar('b_email');
		$transaction['bnameprefix']['g_value'] = JRequest::getVar('bnameprefix');
		$transaction['bnamesuffix']['g_value'] = JRequest::getVar('bnamesuffix');
		$transaction['saddress1']['g_value'] = JRequest::getVar('s_address1');
		$transaction['saddress']['g_value'] = JRequest::getVar('s_address');
		$transaction['scity']['g_value'] = JRequest::getVar('s_city');
		$transaction['sstate']['g_value'] = JRequest::getVar('s_state');
		$transaction['szip']['g_value'] = JRequest::getVar('s_zip');
		$transaction['scountry']['g_value'] = JRequest::getVar('c_country');
		$transaction['sphone']['g_value'] = JRequest::getVar('s_phone');				
		$transaction['s_email']['g_value'] = JRequest::getVar('s_email');
		$transaction['snameprefix']['g_value'] = JRequest::getVar('snameprefix');
		$transaction['snamesuffix']['g_value'] = JRequest::getVar('snamesuffix');
		
		/**Go TO Transection Processing***/
		$response = & $this->PostTransaction($transaction);
		
		if ($response["approval"] != "")
		{
			//print_r($intuit_fields['succ_msg2']['g_value']);
					
			$msgStr = $intuit_fields['succ_msg1']['g_value'] . ' <br />';
			$msgStr .= '<div style="height:5px;"><!-- --></div>';
			$msgStr .= '<span class="msgSPAN">'.$intuit_fields['succ_msg2']['g_value'].'</span>';
			
			return $msgStr;
			
			//return "Your Payment is Approved.<br />";
			
		} else {
			return  "Error: " . $response["error"] . "<br />";
			
		}

    }
	
	function PostTransaction ($transaction) 
	{				
			$url = "https://transactions.innovativegateway.com/servlet/com.gateway.aai.Aai";
			$user_agent = "Mozilla/4.0";
			$proxy = ""; 
			$data = "";				
			foreach ($transaction as $name => $value) {
				$data .= "&" . urlencode($name) . "=" . urlencode($value['g_value']);
			}			
			$data = substr($data,1);			
			// Create the connection through the cURL extension
				$ch = curl_init(); 
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				curl_setopt($ch, CURLOPT_HEADER, 0);
				curl_setopt ($ch, CURLOPT_URL, $url); 
		
			if ($proxy != "")
				curl_setopt ($ch, CURLOPT_PROXY, $proxy); 			
				curl_setopt ($ch, CURLOPT_USERAGENT, $user_agent); 
				curl_setopt ($ch, CURLOPT_POST, 1);
				curl_setopt ($ch, CURLOPT_POSTFIELDS, $data);
				curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1); 
				@curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
				curl_setopt ($ch, CURLOPT_TIMEOUT, 120);
				$result = curl_exec ($ch);
				curl_close($ch);			
			// Now we've got the results back in a big string.			
			// Parse the string into an array to return
			$rArr = explode("|",$result);			
			$returnArr="";
			for($i=0;$i<count($rArr);$i++)
			{
				$tmp2 = explode("=", $rArr[$i]);			
				// YES, we put all returned field names in lowercase
				$tmp2[0] = strtolower($tmp2[0]);			
				// YES, we strip out HTML tags.
				$returnArr[$tmp2[0]] = strip_tags($tmp2[1]);
			}			
			// Return the array.
			return $returnArr;
		}
}